/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef _HW_HDR_H_
#define _HW_HDR_H_
#define IO_HDR_BASE (IO_VIRT + 0x23000)
#endif

#ifndef _HW_PREDOWN_H_
#define _HW_PREDOWN_H_


#include "x_hal_5381.h"

#define IO_PRE_DS_BASE  (IO_VIRT+ 0x23000)

//Page PREDSMAIN
#define PRE_DS_MAIN_00 (IO_PRE_DS_BASE + 0x150)
    #define PRE_DS_MAIN_00_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_00_PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_01 (IO_PRE_DS_BASE + 0x154)
    #define PRE_DS_MAIN_01_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_01_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_02 (IO_PRE_DS_BASE + 0x158)
    #define PRE_DS_MAIN_02_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_02_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_03 (IO_PRE_DS_BASE + 0x15C)
    #define PRE_DS_MAIN_03_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_03_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_04 (IO_PRE_DS_BASE + 0x160)
    #define PRE_DS_MAIN_04_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_04_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_05 (IO_PRE_DS_BASE + 0x164)
    #define PRE_DS_MAIN_05_PREDSMAIN_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_05_PREDSMAIN_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define PRE_DS_MAIN_05_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define PRE_DS_MAIN_05_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define PRE_DS_MAIN_05_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define PRE_DS_MAIN_05_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define PRE_DS_MAIN_05_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define PRE_DS_MAIN_05_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define PRE_DS_MAIN_05_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define PRE_DS_MAIN_05_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define PRE_DS_MAIN_05_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define PRE_DS_MAIN_05_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define PRE_DS_MAIN_05_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define PRE_DS_MAIN_05_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MAIN_06 (IO_PRE_DS_BASE + 0x168)
    #define PRE_DS_MAIN_06_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_06_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_07 (IO_PRE_DS_BASE + 0x16C)
    #define PRE_DS_MAIN_07_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_07_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_08 (IO_PRE_DS_BASE + 0x170)
    #define PRE_DS_MAIN_08_PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_08_PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_09 (IO_PRE_DS_BASE + 0x174)
    #define PRE_DS_MAIN_09_PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_09_PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
#define PRE_DS_MAIN_0A (IO_PRE_DS_BASE + 0x178)
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_SIGN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
#define PRE_DS_MAIN_0B (IO_PRE_DS_BASE + 0x17C)
    #define PRE_DS_MAIN_0B_PREDS_H_PHASE_DELTA_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PRE_DS_MAIN_0B_PREDS_H_PHASE_DELTA_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define PRE_DS_MAIN_0B_PREDS_FIR_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define PRE_DS_MAIN_0B_PREDS_FIR_DLY_SEL Fld(4,3,AC_MSKB0)//[6:3]



//Page PREDSPIP
#define PRE_DS_PIP_00 (IO_PRE_DS_BASE + 0x350)
    #define PRE_DS_PIP_00_PRE_DSCALE_H_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_00_PRE_DSCALER_V_2 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_01 (IO_PRE_DS_BASE + 0x354)
    #define PRE_DS_PIP_01_PRE_DSCALE_H_INIT_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_01_PRE_DSCALE_V_INIT_2 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_02 (IO_PRE_DS_BASE + 0x358)
    #define PRE_DS_PIP_02_PREDS_PIP_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_02_PREDS_PIP_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_03 (IO_PRE_DS_BASE + 0x35C)
    #define PRE_DS_PIP_03_PREDS_PIP_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_03_PREDS_PIP_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_04 (IO_PRE_DS_BASE + 0x360)
    #define PRE_DS_PIP_04_PREDSPIP_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_PIP_04_PREDSPIP_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_PIP_04_PIP_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define PRE_DS_PIP_04_PIP_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_DS_PIP_04_PIP_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define PRE_DS_PIP_04_PIP_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define PRE_DS_PIP_04_PIP_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define PRE_DS_PIP_04_PIP_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define PRE_DS_PIP_04_PIP_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define PRE_DS_PIP_04_PIP_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define PRE_DS_PIP_04_PIP_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define PRE_DS_PIP_04_PREDS_PIP_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define PRE_DS_PIP_04_PREDS_PIP_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define PRE_DS_PIP_04_PRE_DSCALE_H_BYPASS_2 Fld(1,1,AC_MSKB0)//[1:1]
    #define PRE_DS_PIP_04_PRE_DSCALE_V_BYPASS_2 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_PIP_06 (IO_PRE_DS_BASE + 0x368)
    #define PRE_DS_PIP_06_PIP_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_06_PIP_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_07 (IO_PRE_DS_BASE + 0x36C)
    #define PRE_DS_PIP_07_PIP_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_07_PIP_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_08 (IO_PRE_DS_BASE + 0x370)
    #define PRE_DS_PIP_08_PRE_DSCALE_V_INIT_BTM_2 Fld(16,16,AC_FULLW32)//[31:16]
#define PRE_DS_PIP_09 (IO_PRE_DS_BASE + 0x374)
    #define PRE_DS_PIP_09_PREDS_3D_FIELD_EN_2 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_PIP_09_PREDS_3D_FIELD_INV_2 Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_PIP_09_PREDS_PIP_10BIT_BYPASS Fld(1,29,AC_MSKB3)//[29:29]   //gazelle only
//Page HDR2SDR
#define PNSC_CTRL_0 (IO_HDR_BASE + 0xCF8)
    #define HDR_FIFO_RESET Fld(1,16,AC_MSKB2)//[16:16]
    #define C_PNSC_HDR_P_SRC_SWITCH Fld(3,13,AC_MSKB1)//[15:13]
    #define C_PNSC_HDR_M_SRC_SWITCH Fld(3,10,AC_MSKB1)//[12:10]
    #define C_PNSC_HDR_SUB_SRC_SEL Fld(1,9,AC_MSKB1)//[9:9]
    #define C_PNSC_HDR_MAIN_SRC_SEL Fld(1,8,AC_MSKB1)//[8:8]
    #define C_PNSC_HDR_SUB_CEN_SEL Fld(1,7,AC_MSKB0)//[7:7]
    #define C_PNSC_HDR_MAIN_CEN_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define C_PNSC_HDR_SUB_BYPASS Fld(1,5,AC_MSKB0)//[5:5]
    #define C_PNSC_HDR_MAIN_BYPASS_1 Fld(1,4,AC_MSKB0)//[4:4]
    #define C_PNSC_HDR_MAIN_BYPASS_0 Fld(1,3,AC_MSKB0)//[3:3]
    #define C_FSAMPLE_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR2SDR_ATPG (IO_HDR_BASE + 0xCFC)
    #define HDR2SDR_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR2SDR_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_TOP (IO_HDR_BASE + 0xC04)
    #define HDR_ATPG_OB Fld(1,31,AC_MSKB3)//[31:31]
    #define HDR_ATPG_CT Fld(1,30,AC_MSKB3)//[30:30]
    #define BT2020_CONST_LUMA Fld(1,17,AC_MSKB2)//[17:17]
    #define BBC_GAMMA Fld(1,16,AC_MSKB2)//[16:16]
    #define DBUF_READ_WRK Fld(1,15,AC_MSKB1)//[15:15]
    #define DBUF_PROTECT Fld(1,14,AC_MSKB1)//[14:14]
    #define DBUF_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define SDR_GAMMA Fld(1,12,AC_MSKB1)//[12:12]
    #define INK_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define INK_SEL Fld(2,8,AC_MSKB1)//[9:8]
    #define DCM_DIS Fld(1,3,AC_MSKB0)//[3:3]
    #define HDR_RESET Fld(1,2,AC_MSKB0)//[2:2]
    #define BT2020_IN Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_INTERR (IO_HDR_BASE + 0xC08)
    #define INT_BOX_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define INT_HIST_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define INT_OF_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define INT_IF_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_INTSTA (IO_HDR_BASE + 0xC0C)
    #define INT_BOX_END Fld(1,3,AC_MSKB0)//[3:3]
    #define INT_HIST_END Fld(1,2,AC_MSKB0)//[2:2]
    #define INT_OF_END Fld(1,1,AC_MSKB0)//[1:1]
    #define INT_IF_END Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_ENGSTA (IO_HDR_BASE + 0xC10)
    #define STA_CSR_UNF Fld(1,2,AC_MSKB0)//[2:2]
    #define STA_OF_UNF Fld(1,1,AC_MSKB0)//[1:1]
    #define STA_IF_UNF Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_SIZE_0 (IO_HDR_BASE + 0xC14)
    #define IN_VSIZE Fld(13,16,AC_MSKW32)//[28:16]
    #define IN_HSIZE Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_HIST_CTRL_0 (IO_HDR_BASE + 0xC20)
    #define HIST_BEGIN_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define HIST_BEGIN_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_HIST_CTRL_1 (IO_HDR_BASE + 0xC24)
    #define HIST_END_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define HIST_END_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_DEMO_CTRL_0 (IO_HDR_BASE + 0xC28)
    #define DEMO_BEGIN_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define DEMO_BEGIN_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_DEMO_CTRL_1 (IO_HDR_BASE + 0xC2C)
    #define HDR_DEMO_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define DEMO_SEL Fld(1,30,AC_MSKB3)//[30:30]
    #define DEMO_END_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define DEMO_END_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_3X3_COEF_0 (IO_HDR_BASE + 0xC30)
    #define GAMUT_ROUND_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define GAMUT_MATRIX_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_3X3_COEF_1 (IO_HDR_BASE + 0xC34)
    #define C01 Fld(16,16,AC_FULLW32)//[31:16]
    #define C00 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_2 (IO_HDR_BASE + 0xC38)
    #define C10 Fld(16,16,AC_FULLW32)//[31:16]
    #define C02 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_3 (IO_HDR_BASE + 0xC3C)
    #define C12 Fld(16,16,AC_FULLW32)//[31:16]
    #define C11 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_4 (IO_HDR_BASE + 0xC40)
    #define C21 Fld(16,16,AC_FULLW32)//[31:16]
    #define C20 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_5 (IO_HDR_BASE + 0xC44)
    #define C22 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_6 (IO_HDR_BASE + 0xC48)
    #define PRE_ADD_0 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_7 (IO_HDR_BASE + 0xC4C)
    #define PRE_ADD_1 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_8 (IO_HDR_BASE + 0xC50)
    #define PRE_ADD_2 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_9 (IO_PIO_HDR_BASERE_DS_BASE + 0xC54)
    #define POST_ADD_0 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_10 (IO_HDR_BASE + 0xC58)
    #define POST_ADD_1 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_11 (IO_HDR_BASE + 0xC5C)
    #define POST_ADD_2 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_TONE_MAP_P12 (IO_HDR_BASE + 0xC60)
    #define REG_P2 Fld(16,16,AC_FULLW32)//[31:16]
    #define REG_P1 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_P34 (IO_HDR_BASE + 0xC64)
    #define REG_P4 Fld(16,16,AC_FULLW32)//[31:16]
    #define REG_P3 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_P5 (IO_HDR_BASE + 0xC68)
    #define REG_P5 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_S0 (IO_HDR_BASE + 0xC6C)
    #define REG_SLOPE0 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S1 (IO_HDR_BASE + 0xC70)
    #define REG_SLOPE1 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S2 (IO_HDR_BASE + 0xC74)
    #define REG_SLOPE2 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S3 (IO_HDR_BASE+ 0xC78)
    #define REG_SLOPE3 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S4 (IO_HDR_BASE + 0xC7C)
    #define REG_SLOPE4 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_B_CHANNEL_NR (IO_HDR_BASE + 0xC80)
    #define REG_NR_STRENGTH Fld(4,4,AC_MSKB0)//[7:4]
    #define REG_FILTER_NO Fld(1,1,AC_MSKB0)//[1:1]
    #define REG_NR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_HIST_ADDR (IO_HDR_BASE + 0xC84)
    #define HIST_PING_PONG_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define HIST_MSB_SHIFT_VALID Fld(1,29,AC_MSKB3)//[29:29]
    #define HIST_MSB_SHIFT Fld(5,24,AC_MSKB3)//[28:24]
    #define LAST_NON_ZERO_BIN Fld(6,16,AC_MSKB2)//[21:16]
    #define HIST_READ_FULL Fld(1,13,AC_MSKB1)//[13:13]
    #define HIST_ADDR_AUTO_INC_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define HIST_ADDR_AUTO_INC_RW Fld(1,10,AC_MSKB1)//[10:10]
    #define HIST_CLR_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define REG_HIST_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define HIST_ADDR Fld(6,0,AC_MSKB0)//[5:0]
#define HDR_HIST_DATA (IO_HDR_BASE + 0xC88)
    #define HIST_DATA Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_A_LUMINANCE (IO_HDR_BASE + 0xC8C)
    #define REG_MAXRGB_WEIGHT Fld(4,4,AC_MSKB0)//[7:4]
    #define REG_LUMA_GAIN_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_GAIN_TABLE_0 (IO_HDR_BASE + 0xC90)
    #define GAIN_TABLE_PING_PONG_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define GAIN_TABLE_STATUS Fld(1,14,AC_MSKB1)//[14:14]
    #define GAIN_TABLE_ODD_WEN Fld(1,13,AC_MSKB1)//[13:13]
    #define GAIN_TABLE_EVEN_WEN Fld(1,12,AC_MSKB1)//[12:12]
    #define GAIN_TABLE_ADDR_AUTO_INC_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define GAIN_TABLE_ADDR_AUTO_INC_RW Fld(1,10,AC_MSKB1)//[10:10]
    #define GAIN_TABLE_UPDATE Fld(1,8,AC_MSKB1)//[8:8]
    #define GAIN_TABLE_ADDR Fld(7,0,AC_MSKB0)//[6:0]
#define HDR_GAIN_TABLE_1 (IO_HDR_BASE + 0xC94)
    #define GAIN_TABLE_DATA Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_Y2R_R2Y (IO_HDR_BASE + 0xC98)
    #define Y2R_ROUND_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define R2Y_ROUND_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_LBOX_DET_1 (IO_HDR_BASE + 0xC9C)
    #define RT_SKIP Fld(8,24,AC_FULLB3)//[31:24]
    #define LF_SKIP Fld(8,16,AC_FULLB2)//[23:16]
    #define BLACK_Y_LEVEL Fld(8,8,AC_FULLB1)//[15:8]
    #define OUTPUT_OFFSET Fld(4,4,AC_MSKB0)//[7:4]
    #define LBOX_DET_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_LBOX_DET_2 (IO_HDR_BASE + 0xCA0)
    #define START_DET_POS Fld(8,0,AC_FULLB0)//[7:0]
#define HDR_LBOX_DET_3 (IO_HDR_BASE + 0xCA4)
    #define DNPOS Fld(13,16,AC_MSKW32)//[28:16]
    #define UPPOS Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_CURSOR_CTRL (IO_HDR_BASE + 0xCA8)
    #define CURSOR_SEL Fld(4,4,AC_MSKB0)//[7:4]
    #define CURSOR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_CURSOR_POS (IO_HDR_BASE + 0xCAC)
    #define CURSOR_TARGV Fld(13,16,AC_MSKW32)//[28:16]
    #define CURSOR_TARGH Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_CURSOR_COLOR (IO_HDR_BASE + 0xCB0)
    #define CURSOR_CR Fld(4,8,AC_MSKB1)//[11:8]
    #define CURSOR_CB Fld(4,4,AC_MSKB0)//[7:4]
    #define CURSOR_Y Fld(4,0,AC_MSKB0)//[3:0]
#define HDR_CURSOR_BUF0 (IO_HDR_BASE + 0xCB8)
    #define CURSOR_BUFFER1 Fld(16,16,AC_FULLW32)//[31:16]
    #define CURSOR_BUFFER0 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_CURSOR_BUF1 (IO_HDR_BASE + 0xCBC)
    #define CURSOR_BUFFER2 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_DUMMY0 (IO_HDR_BASE + 0xCC0)
    #define HDR_DUMMY_0 Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_DUMMY1 (IO_HDR_BASE + 0xCC4)
    #define HDR_DUMMY_1 Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_DUMMY2 (IO_HDR_BASE + 0xCC8)
    #define HDR_DUMMY_2 Fld(32,0,AC_FULLDW)//[31:0]
/*
//Page TNR_DS_1
#define TNR_DS_MAIN_00 (IO_TNR_BASE + 0x150)
    #define TNR_DS_MAIN_00_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_00_PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_01 (IO_TNR_BASE + 0x154)
    #define TNR_DS_MAIN_01_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_01_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_02 (IO_TNR_BASE + 0x158)
    #define TNR_DS_MAIN_02_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_02_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_03 (IO_TNR_BASE + 0x15C)
    #define TNR_DS_MAIN_03_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_03_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_04 (IO_TNR_BASE + 0x160)
    #define TNR_DS_MAIN_04_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_04_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_05 (IO_TNR_BASE + 0x164)
    #define TNR_DS_MAIN_05_TNR_DS_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define TNR_DS_MAIN_05_TNR_DS_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define TNR_DS_MAIN_05_MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define TNR_DS_MAIN_05_MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define TNR_DS_MAIN_05_MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define TNR_DS_MAIN_05_MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define TNR_DS_MAIN_05_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_MAIN_05_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define TNR_DS_MAIN_05_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define TNR_DS_MAIN_05_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define TNR_DS_MAIN_05_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define TNR_DS_MAIN_05_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define TNR_DS_MAIN_05_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define TNR_DS_MAIN_05_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define TNR_DS_MAIN_05_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define TNR_DS_MAIN_05_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define TNR_DS_MAIN_05_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define TNR_DS_MAIN_05_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define TNR_DS_MAIN_06 (IO_TNR_BASE + 0x168)
    #define TNR_DS_MAIN_06_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_06_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_07 (IO_TNR_BASE + 0x16C)
    #define TNR_DS_MAIN_07_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_07_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_08 (IO_TNR_BASE + 0x170)
    #define TNR_DS_MAIN_08_PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_MAIN_08_PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_MAIN_09 (IO_TNR_BASE + 0x174)
    #define TNR_DS_MAIN_09_PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define TNR_DS_MAIN_09_PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define TNR_DS_MAIN_09_PREDS_RESERVE_0 Fld(1,0,AC_MSKB0)//[0:0]
#define TNR_DS_MAIN_0A (IO_TNR_BASE + 0x178)
    #define TNR_DS_MAIN_0A_PREDS_H_PHASE_INIT_SIGN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define TNR_DS_MAIN_0A_PREDS_H_PHASE_INIT_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define TNR_DS_MAIN_0A_PREDS_H_PHASE_INIT_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define TNR_DS_MAIN_0A_PREDS_FIR_COEF_SEL Fld(3,0,AC_MSKB0)//[2:0]
#define TNR_DS_MAIN_0B (IO_TNR_BASE + 0x17C)
    #define TNR_DS_MAIN_0B_PREDS_H_PHASE_DELTA_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define TNR_DS_MAIN_0B_PREDS_H_PHASE_DELTA_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define TNR_DS_MAIN_0B_PREDS_FIR_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define TNR_DS_MAIN_0B_PREDS_FIR_DLY_SEL Fld(4,3,AC_MSKB0)//[6:3]
    #define TNR_DS_MAIN_0B_PREDS_FIR_INPUT_DLY_SEL Fld(1,1,AC_MSKB0)//[1:1]
    #define TNR_DS_MAIN_0B_PREDS_CEN_OUT_SEL Fld(1,0,AC_MSKB0)//[0:0]
#define TNR_DS_FIL_00 (IO_TNR_BASE + 0x800)
    #define TNR_DS_FIL_00_H_FILTER_BAND0_COEF0 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_00_H_FILTER_BAND0_COEF1 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_00_H_FILTER_BAND0_COEF2 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_01 (IO_TNR_BASE + 0x804)
    #define TNR_DS_FIL_01_H_FILTER_BAND0_COEF3 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_01_H_FILTER_BAND0_COEF4 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_01_H_FILTER_BAND0_COEF5 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_02 (IO_TNR_BASE + 0x808)
    #define TNR_DS_FIL_02_H_FILTER_BAND0_COEF6 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_02_H_FILTER_BAND0_COEF7 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_02_H_FILTER_BAND0_COEF8 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_03 (IO_TNR_BASE + 0x80C)
    #define TNR_DS_FIL_03_H_FILTER_BAND0_COEF9 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_03_H_FILTER_BAND0_COEF10 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_03_H_FILTER_BAND0_COEF11 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_04 (IO_TNR_BASE + 0x810)
    #define TNR_DS_FIL_04_H_FILTER_BAND0_COEF12 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_04_H_FILTER_BAND0_COEF13 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_04_H_FILTER_BAND0_COEF14 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_05 (IO_TNR_BASE + 0x814)
    #define TNR_DS_FIL_05_H_FILTER_BAND0_COEF15 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_05_H_FILTER_BAND0_COEF16 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_05_H_FILTER_BAND0_COEF17 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_06 (IO_TNR_BASE + 0x81C)
    #define TNR_DS_FIL_06_H_FILTER_BAND0_COEF18 Fld(10,20,AC_MSKW32)//[29:20]
    #define TNR_DS_FIL_06_H_FILTER_BAND0_COEF19 Fld(10,10,AC_MSKW21)//[19:10]
    #define TNR_DS_FIL_06_H_FILTER_BAND0_COEF20 Fld(10,0,AC_MSKW10)//[9:0]
#define TNR_DS_FIL_07 (IO_TNR_BASE + 0x820)
    #define TNR_DS_FIL_07_H_FILTER_BAND1_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_07_H_FILTER_BAND1_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_07_H_FILTER_BAND1_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_07_H_FILTER_BAND1_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_08 (IO_TNR_BASE + 0x824)
    #define TNR_DS_FIL_08_H_FILTER_BAND1_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_08_H_FILTER_BAND1_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_08_H_FILTER_BAND1_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_08_H_FILTER_BAND1_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_09 (IO_TNR_BASE + 0x82C)
    #define TNR_DS_FIL_09_H_FILTER_BAND1_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_09_H_FILTER_BAND1_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_09_H_FILTER_BAND1_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_09_H_FILTER_BAND1_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0A (IO_TNR_BASE + 0x830)
    #define TNR_DS_FIL_0A_H_FILTER_BAND1_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0A_H_FILTER_BAND1_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0A_H_FILTER_BAND1_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0B (IO_TNR_BASE + 0x834)
    #define TNR_DS_FIL_0B_H_FILTER_BAND2_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_0B_H_FILTER_BAND2_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0B_H_FILTER_BAND2_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0B_H_FILTER_BAND2_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0C (IO_TNR_BASE + 0x83C)
    #define TNR_DS_FIL_0C_H_FILTER_BAND2_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_0C_H_FILTER_BAND2_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0C_H_FILTER_BAND2_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0C_H_FILTER_BAND2_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0D (IO_TNR_BASE + 0x840)
    #define TNR_DS_FIL_0D_H_FILTER_BAND2_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_0D_H_FILTER_BAND2_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0D_H_FILTER_BAND2_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0D_H_FILTER_BAND2_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0E (IO_TNR_BASE + 0x844)
    #define TNR_DS_FIL_0E_H_FILTER_BAND2_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0E_H_FILTER_BAND2_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0E_H_FILTER_BAND2_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_0F (IO_TNR_BASE + 0x84C)
    #define TNR_DS_FIL_0F_H_FILTER_BAND3_COEF0 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_0F_H_FILTER_BAND3_COEF1 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_0F_H_FILTER_BAND3_COEF2 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_0F_H_FILTER_BAND3_COEF3 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_10 (IO_TNR_BASE + 0x850)
    #define TNR_DS_FIL_10_H_FILTER_BAND3_COEF4 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_10_H_FILTER_BAND3_COEF5 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_10_H_FILTER_BAND3_COEF6 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_10_H_FILTER_BAND3_COEF7 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_11 (IO_TNR_BASE + 0x854)
    #define TNR_DS_FIL_11_H_FILTER_BAND3_COEF8 Fld(8,24,AC_FULLB3)//[31:24]
    #define TNR_DS_FIL_11_H_FILTER_BAND3_COEF9 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_11_H_FILTER_BAND3_COEF10 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_11_H_FILTER_BAND3_COEF11 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_12 (IO_TNR_BASE + 0x85C)
    #define TNR_DS_FIL_12_H_FILTER_BAND3_COEF12 Fld(8,16,AC_FULLB2)//[23:16]
    #define TNR_DS_FIL_12_H_FILTER_BAND3_COEF13 Fld(8,8,AC_FULLB1)//[15:8]
    #define TNR_DS_FIL_12_H_FILTER_BAND3_COEF14 Fld(8,0,AC_FULLB0)//[7:0]
#define TNR_DS_FIL_13 (IO_TNR_BASE + 0x860)
    #define TNR_DS_FIL_13_H_FILTER_WIDTH Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_FIL_13_H_FILTER_HEIGHT Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_FIL_14 (IO_TNR_BASE + 0x864)
    #define TNR_DS_FIL_14_H_FILTER_H_START Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_FIL_14_H_FILTER_V_START Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_FIL_15 (IO_TNR_BASE + 0x86C)
    #define TNR_DS_FIL_15_H_FILTER_H_SIZE Fld(16,16,AC_FULLW32)//[31:16]
    #define TNR_DS_FIL_15_H_FILTER_V_SIZE Fld(16,0,AC_FULLW10)//[15:0]
#define TNR_DS_FIL_16 (IO_TNR_BASE + 0x870)
    #define TNR_DS_FIL_16_H_FILTER_SWITCH_0 Fld(1,31,AC_MSKB3)//[31:31]
    #define TNR_DS_FIL_16_H_FILTER_SWITCH_1 Fld(1,30,AC_MSKB3)//[30:30]
    #define TNR_DS_FIL_16_H_FILTER_SWITCH_2 Fld(1,29,AC_MSKB3)//[29:29]
    #define TNR_DS_FIL_16_H_FILTER_SWITCH_3 Fld(1,28,AC_MSKB3)//[28:28]
    #define TNR_DS_FIL_16_BITSHIFT_A0 Fld(3,25,AC_MSKB3)//[27:25]
    #define TNR_DS_FIL_16_BITSHIFT_B0 Fld(3,22,AC_MSKW32)//[24:22]
    #define TNR_DS_FIL_16_BITSHIFT_A1 Fld(3,19,AC_MSKB2)//[21:19]
    #define TNR_DS_FIL_16_BITSHIFT_B1 Fld(3,16,AC_MSKB2)//[18:16]
    #define TNR_DS_FIL_16_BITSHIFT_A2 Fld(3,13,AC_MSKB1)//[15:13]
    #define TNR_DS_FIL_16_BITSHIFT_B2 Fld(3,10,AC_MSKB1)//[12:10]
    #define TNR_DS_FIL_16_BITSHIFT_A3 Fld(3,7,AC_MSKW10)//[9:7]
    #define TNR_DS_FIL_16_BITSHIFT_B3 Fld(3,4,AC_MSKB0)//[6:4]
    #define TNR_DS_FIL_16_H_FILTER_OUTPUT_MSB Fld(1,3,AC_MSKB0)//[3:3]
#define TNR_DS_FIL_17 (IO_TNR_BASE + 0x874)
    #define TNR_DS_FIL_17_A0_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_18 (IO_TNR_BASE + 0x878)
    #define TNR_DS_FIL_18_A0_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_19 (IO_TNR_BASE + 0x87C)
    #define TNR_DS_FIL_19_A0_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1A (IO_TNR_BASE + 0x880)
    #define TNR_DS_FIL_1A_A0_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1B (IO_TNR_BASE + 0x884)
    #define TNR_DS_FIL_1B_A0_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1C (IO_TNR_BASE + 0x888)
    #define TNR_DS_FIL_1C_A0_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1D (IO_TNR_BASE + 0x88C)
    #define TNR_DS_FIL_1D_A0_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1E (IO_TNR_BASE + 0x890)
    #define TNR_DS_FIL_1E_A0_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_1F (IO_TNR_BASE + 0x894)
    #define TNR_DS_FIL_1F_A0_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_20 (IO_TNR_BASE + 0x898)
    #define TNR_DS_FIL_20_A0_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_21 (IO_TNR_BASE + 0x89C)
    #define TNR_DS_FIL_21_A0_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_22 (IO_TNR_BASE + 0x8A0)
    #define TNR_DS_FIL_22_A0_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_23 (IO_TNR_BASE + 0x8A4)
    #define TNR_DS_FIL_23_A0_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_24 (IO_TNR_BASE + 0x8A8)
    #define TNR_DS_FIL_24_A0_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_25 (IO_TNR_BASE + 0x8AC)
    #define TNR_DS_FIL_25_A0_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_26 (IO_TNR_BASE + 0x8B0)
    #define TNR_DS_FIL_26_A0_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_27 (IO_TNR_BASE + 0x8B4)
    #define TNR_DS_FIL_27_B0_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_28 (IO_TNR_BASE + 0x8B8)
    #define TNR_DS_FIL_28_B0_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_29 (IO_TNR_BASE + 0x8BC)
    #define TNR_DS_FIL_29_B0_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2A (IO_TNR_BASE + 0x8C0)
    #define TNR_DS_FIL_2A_B0_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2B (IO_TNR_BASE + 0x8C4)
    #define TNR_DS_FIL_2B_B0_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2C (IO_TNR_BASE + 0x8C8)
    #define TNR_DS_FIL_2C_B0_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2D (IO_TNR_BASE + 0x8CC)
    #define TNR_DS_FIL_2D_B0_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2E (IO_TNR_BASE + 0x8D0)
    #define TNR_DS_FIL_2E_B0_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_2F (IO_TNR_BASE + 0x8D4)
    #define TNR_DS_FIL_2F_B0_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_30 (IO_TNR_BASE + 0x8D8)
    #define TNR_DS_FIL_30_B0_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_31 (IO_TNR_BASE + 0x8DC)
    #define TNR_DS_FIL_31_B0_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_32 (IO_TNR_BASE + 0x8E0)
    #define TNR_DS_FIL_32_B0_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_33 (IO_TNR_BASE + 0x8E4)
    #define TNR_DS_FIL_33_B0_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_34 (IO_TNR_BASE + 0x8E8)
    #define TNR_DS_FIL_34_B0_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_35 (IO_TNR_BASE + 0x8EC)
    #define TNR_DS_FIL_35_B0_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_36 (IO_TNR_BASE + 0x8F0)
    #define TNR_DS_FIL_36_B0_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_37 (IO_TNR_BASE + 0x8F4)
    #define TNR_DS_FIL_37_A1_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_38 (IO_TNR_BASE + 0x8F8)
    #define TNR_DS_FIL_38_A1_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_39 (IO_TNR_BASE + 0x8FC)
    #define TNR_DS_FIL_39_A1_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3A (IO_TNR_BASE + 0x900)
    #define TNR_DS_FIL_3A_A1_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3B (IO_TNR_BASE + 0x904)
    #define TNR_DS_FIL_3B_A1_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3C (IO_TNR_BASE + 0x908)
    #define TNR_DS_FIL_3C_A1_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3D (IO_TNR_BASE + 0x90C)
    #define TNR_DS_FIL_3D_A1_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3E (IO_TNR_BASE + 0x910)
    #define TNR_DS_FIL_3E_A1_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_3F (IO_TNR_BASE + 0x914)
    #define TNR_DS_FIL_3F_A1_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_40 (IO_TNR_BASE + 0x918)
    #define TNR_DS_FIL_40_A1_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_41 (IO_TNR_BASE + 0x91C)
    #define TNR_DS_FIL_41_A1_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_42 (IO_TNR_BASE + 0x920)
    #define TNR_DS_FIL_42_A1_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_43 (IO_TNR_BASE + 0x924)
    #define TNR_DS_FIL_43_A1_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_44 (IO_TNR_BASE + 0x928)
    #define TNR_DS_FIL_44_A1_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_45 (IO_TNR_BASE + 0x92C)
    #define TNR_DS_FIL_45_A1_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_46 (IO_TNR_BASE + 0x930)
    #define TNR_DS_FIL_46_A1_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_47 (IO_TNR_BASE + 0x934)
    #define TNR_DS_FIL_47_B1_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_48 (IO_TNR_BASE + 0x938)
    #define TNR_DS_FIL_48_B1_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_49 (IO_TNR_BASE + 0x93C)
    #define TNR_DS_FIL_49_B1_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4A (IO_TNR_BASE + 0x940)
    #define TNR_DS_FIL_4A_B1_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4B (IO_TNR_BASE + 0x944)
    #define TNR_DS_FIL_4B_B1_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4C (IO_TNR_BASE + 0x948)
    #define TNR_DS_FIL_4C_B1_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4D (IO_TNR_BASE + 0x94C)
    #define TNR_DS_FIL_4D_B1_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4E (IO_TNR_BASE + 0x950)
    #define TNR_DS_FIL_4E_B1_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_4F (IO_TNR_BASE + 0x954)
    #define TNR_DS_FIL_4F_B1_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_50 (IO_TNR_BASE + 0x958)
    #define TNR_DS_FIL_50_B1_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_51 (IO_TNR_BASE + 0x95C)
    #define TNR_DS_FIL_51_B1_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_52 (IO_TNR_BASE + 0x960)
    #define TNR_DS_FIL_52_B1_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_53 (IO_TNR_BASE + 0x964)
    #define TNR_DS_FIL_53_B1_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_54 (IO_TNR_BASE + 0x968)
    #define TNR_DS_FIL_54_B1_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_55 (IO_TNR_BASE + 0x96C)
    #define TNR_DS_FIL_55_B1_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_56 (IO_TNR_BASE + 0x970)
    #define TNR_DS_FIL_56_B1_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_57 (IO_TNR_BASE + 0x974)
    #define TNR_DS_FIL_57_A2_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_58 (IO_TNR_BASE + 0x978)
    #define TNR_DS_FIL_58_A2_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_59 (IO_TNR_BASE + 0x97C)
    #define TNR_DS_FIL_59_A2_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5A (IO_TNR_BASE + 0x980)
    #define TNR_DS_FIL_5A_A2_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5B (IO_TNR_BASE + 0x984)
    #define TNR_DS_FIL_5B_A2_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5C (IO_TNR_BASE + 0x988)
    #define TNR_DS_FIL_5C_A2_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5D (IO_TNR_BASE + 0x98C)
    #define TNR_DS_FIL_5D_A2_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5E (IO_TNR_BASE + 0x990)
    #define TNR_DS_FIL_5E_A2_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_5F (IO_TNR_BASE + 0x994)
    #define TNR_DS_FIL_5F_A2_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_60 (IO_TNR_BASE + 0x998)
    #define TNR_DS_FIL_60_A2_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_61 (IO_TNR_BASE + 0x99C)
    #define TNR_DS_FIL_61_A2_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_62 (IO_TNR_BASE + 0x9A0)
    #define TNR_DS_FIL_62_A2_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]

//Page TNR_DS_2
#define TNR_DS_FIL_63 (IO_TNR_BASE + 0x9A4)
    #define TNR_DS_FIL_63_A2_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_64 (IO_TNR_BASE + 0x9A8)
    #define TNR_DS_FIL_64_A2_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_65 (IO_TNR_BASE + 0x9AC)
    #define TNR_DS_FIL_65_A2_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_66 (IO_TNR_BASE + 0x9B0)
    #define TNR_DS_FIL_66_A2_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_67 (IO_TNR_BASE + 0x9B4)
    #define TNR_DS_FIL_67_B2_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_68 (IO_TNR_BASE + 0x9B8)
    #define TNR_DS_FIL_68_B2_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_69 (IO_TNR_BASE + 0x9BC)
    #define TNR_DS_FIL_69_B2_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6A (IO_TNR_BASE + 0x9C0)
    #define TNR_DS_FIL_6A_B2_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6B (IO_TNR_BASE + 0x9C4)
    #define TNR_DS_FIL_6B_B2_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6C (IO_TNR_BASE + 0x9C8)
    #define TNR_DS_FIL_6C_B2_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6D (IO_TNR_BASE + 0x9CC)
    #define TNR_DS_FIL_6D_B2_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6E (IO_TNR_BASE + 0x9D0)
    #define TNR_DS_FIL_6E_B2_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_6F (IO_TNR_BASE + 0x9D4)
    #define TNR_DS_FIL_6F_B2_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_70 (IO_TNR_BASE + 0x9D8)
    #define TNR_DS_FIL_70_B2_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_71 (IO_TNR_BASE + 0x9DC)
    #define TNR_DS_FIL_71_B2_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_72 (IO_TNR_BASE + 0x9E0)
    #define TNR_DS_FIL_72_B2_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_73 (IO_TNR_BASE + 0x9E4)
    #define TNR_DS_FIL_73_B2_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_74 (IO_TNR_BASE + 0x9E8)
    #define TNR_DS_FIL_74_B2_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_75 (IO_TNR_BASE + 0x9EC)
    #define TNR_DS_FIL_75_B2_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_76 (IO_TNR_BASE + 0x9F0)
    #define TNR_DS_FIL_76_B2_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_77 (IO_TNR_BASE + 0x9F4)
    #define TNR_DS_FIL_77_A3_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_78 (IO_TNR_BASE + 0x9F8)
    #define TNR_DS_FIL_78_A3_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_79 (IO_TNR_BASE + 0x9FC)
    #define TNR_DS_FIL_79_A3_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7A (IO_TNR_BASE + 0xA00)
    #define TNR_DS_FIL_7A_A3_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7B (IO_TNR_BASE + 0xA04)
    #define TNR_DS_FIL_7B_A3_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7C (IO_TNR_BASE + 0xA08)
    #define TNR_DS_FIL_7C_A3_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7D (IO_TNR_BASE + 0xA0C)
    #define TNR_DS_FIL_7D_A3_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7E (IO_TNR_BASE + 0xA10)
    #define TNR_DS_FIL_7E_A3_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_7F (IO_TNR_BASE + 0xA14)
    #define TNR_DS_FIL_7F_A3_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_80 (IO_TNR_BASE + 0xA18)
    #define TNR_DS_FIL_80_A3_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_81 (IO_TNR_BASE + 0xA1C)
    #define TNR_DS_FIL_81_A3_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_82 (IO_TNR_BASE + 0xA20)
    #define TNR_DS_FIL_82_A3_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_83 (IO_TNR_BASE + 0xA24)
    #define TNR_DS_FIL_83_A3_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_84 (IO_TNR_BASE + 0xA28)
    #define TNR_DS_FIL_84_A3_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_85 (IO_TNR_BASE + 0xA2C)
    #define TNR_DS_FIL_85_A3_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_86 (IO_TNR_BASE + 0xA30)
    #define TNR_DS_FIL_86_A3_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_87 (IO_TNR_BASE + 0xA34)
    #define TNR_DS_FIL_87_B3_HIST_0 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_88 (IO_TNR_BASE + 0xA38)
    #define TNR_DS_FIL_88_B3_HIST_1 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_89 (IO_TNR_BASE + 0xA3C)
    #define TNR_DS_FIL_89_B3_HIST_2 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8A (IO_TNR_BASE + 0xA40)
    #define TNR_DS_FIL_8A_B3_HIST_3 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8B (IO_TNR_BASE + 0xA44)
    #define TNR_DS_FIL_8B_B3_HIST_4 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8C (IO_TNR_BASE + 0xA48)
    #define TNR_DS_FIL_8C_B3_HIST_5 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8D (IO_TNR_BASE + 0xA4C)
    #define TNR_DS_FIL_8D_B3_HIST_6 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8E (IO_TNR_BASE + 0xA50)
    #define TNR_DS_FIL_8E_B3_HIST_7 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_8F (IO_TNR_BASE + 0xA54)
    #define TNR_DS_FIL_8F_B3_HIST_8 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_90 (IO_TNR_BASE + 0xA58)
    #define TNR_DS_FIL_90_B3_HIST_9 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_91 (IO_TNR_BASE + 0xA5C)
    #define TNR_DS_FIL_91_B3_HIST_10 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_92 (IO_TNR_BASE + 0xA60)
    #define TNR_DS_FIL_92_B3_HIST_11 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_93 (IO_TNR_BASE + 0xA64)
    #define TNR_DS_FIL_93_B3_HIST_12 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_94 (IO_TNR_BASE + 0xA68)
    #define TNR_DS_FIL_94_B3_HIST_13 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_95 (IO_TNR_BASE + 0xA6C)
    #define TNR_DS_FIL_95_B3_HIST_14 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_96 (IO_TNR_BASE + 0xA70)
    #define TNR_DS_FIL_96_B3_HIST_15 Fld(24,0,AC_MSKDW)//[23:0]
#define TNR_DS_FIL_97 (IO_TNR_BASE + 0xA74)
    #define TNR_DS_FIL_97_H_FILTER_BAND0_DIV Fld(4,28,AC_MSKB3)//[31:28]
    #define TNR_DS_FIL_97_H_FILTER_BAND1_DIV Fld(4,24,AC_MSKB3)//[27:24]
    #define TNR_DS_FIL_97_H_FILTER_BAND2_DIV Fld(4,20,AC_MSKB2)//[23:20]
    #define TNR_DS_FIL_97_H_FILTER_BAND3_DIV Fld(4,16,AC_MSKB2)//[19:16]
    #define TNR_DS_FIL_97_H_FILTER_VSYNC_INV Fld(1,15,AC_MSKB1)//[15:15]
    #define TNR_DS_FIL_97_H_FILTER_X0_CNT_SEL Fld(1,14,AC_MSKB1)//[14:14]
*/
#endif    
