/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 * Copyright (c) 2004, MediaTek Inc.
 * All rights reserved.
 * 
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.  
 *-----------------------------------------------------------------------------
 * $RCSfile: x_vid_enc.h,v $
 * $Revision: #1 $
 * $Date: 2015/11/26 $
 * $Author: dtvbm11 $
 *
 * Description:
 *         This header file contains Personal Video Recorder driver exported definitions.
 *---------------------------------------------------------------------------*/

#ifndef _X_VID_ENC_H_
#define _X_VID_ENC_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

#include "x_common.h"
#include "x_rm.h"
#include "x_mm_common.h"


/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
 -----------------------------------------------------------------------------*/

/* Get operations */
#define VID_ENC_GET_TYPE_CTRL              ( RM_GET_TYPE_LAST_ENTRY + ( ( DRV_GET_TYPE_T )  0 ) )


/* Set operations */
#define VID_ENC_SET_TYPE_CTRL              ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 0 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_SETTINGS          ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 1 ) )
#define VID_ENC_SET_TYPE_FRAME_RESOLUTION  ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 2 ) )
#define VID_ENC_SET_TYPE_FRAME_RATE        ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 3 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_BITRATE           ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 4 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_PROFILE           ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 5 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_LEVEL             ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 6 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_APP_TYPE          ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 7 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_RESTART           ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 8 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_INSERT_KEYFRAME   ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 9 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_ENABLE_OSTG       ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 10 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_ENCODE_OSD        ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 11 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_INPUT_SOURCE      ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 12) ) 
#define VID_ENC_SET_TYPE_ENCODE_FIELD      ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 13 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_CONST_QUALITY     ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 14 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_ENCODE_INPUT      ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 15 ) ) | RM_SET_TYPE_ARG_NO_REF )
#define VID_ENC_SET_TYPE_ENCODE_MODULE     ( ( RM_SET_TYPE_LAST_ENTRY + ( ( DRV_SET_TYPE_T) 16 ) ) | RM_SET_TYPE_ARG_NO_REF )

/**  VID_ENCMTVENC_SRC_TYPE_T
 *  set the record input point
 */
typedef enum
{
    VID_ENC_VDP_VENC_MIXER = 0,                    ///< encoder MIXER
    VID_ENC_VDP_VENC_MAIN_FSC_OUT,
    VID_ENC_VDP_VENC_SUB_FSC_OUT,
    VID_ENC_VDP_VENC_MAIN_MIB_OUT,
    VID_ENC_VDP_VENC_SUB_MIB_OUT,
    VID_ENC_VDP_VENC_MAIN_BEFORE_PRED ,           ///< encoder before MAIN predown
    VID_ENC_VDP_VENC_SUB_BEFORE_PRED,             ///< encoder before SUB predown
    VID_ENC_VDP_VENC_OSTG,                        ///< encode output stage
    VID_ENC_VDP_VENC_OSTG_OSD  ,                  ///< encode output stage + OSD
    VID_ENC_VDP_VENC_NOT_SELECTED,                ///< encode input is not selected
}VID_ENC_VDP_VENC_INPUT;

/*for VID_ENC_FLD_TYPE_T*/
typedef enum
{
    VID_ENC_FLD_NORMAL = 0,
    VID_ENC_TOP_FLD,
    VID_ENC_BOTTOM_FLD,
} VID_ENC_FLD_TYPE_T;


/* Note refer to MUX_UTIL_VID_SRC_TYPE_T*/
typedef enum
{
    VID_ENC_SRC_TYPE_VDEC = 0, /*For Internal skype*/
    VID_ENC_SRC_TYPE_VDP,      /*for mt5396: support MSI, ATV PVR, ATV Backgorund PVR*/
} VID_SRC_TYPE_T;

/*for VID_ENC_SET_TYPE_APP_TYPE*/
typedef enum
{
    VID_ENC_AP_TYPE_SKYPE = 0,
    VID_ENC_AP_TYPE_ATVPVR,
    VID_ENC_AP_TYPE_MSI,  // multi-screen interaction, for mt5396
    VID_ENC_AP_TYPE_BGPVR,
} VID_AP_TYPE_T;

typedef enum
{
    VID_ENC_FMT_H264 = 0
    /* Others */
} VID_ENC_FMT_TYPE_T;

typedef enum 
{
    /* H264 */
    VID_ENC_H264_PROFILE_BASELINE = 0,
    VID_ENC_H264_PROFILE_MAIN 
    /* Others */
} VID_ENC_PROFILE_T;


typedef enum 
{
    /* H264 */
    VID_ENC_H264_LEVEL_21 = 0,
    VID_ENC_H264_LEVEL_30,
    VID_ENC_H264_LEVEL_31,
    VID_ENC_H264_LEVEL_41    
    /* Others */
} VID_ENC_LEVEL_T;

typedef struct _VID_ENC_INPUT_SOURCE_T
{
    DRV_TYPE_T         e_type;
    UINT16             ui2_comp_id;
}VID_ENC_INPUT_SOURCE_T;


/*-----------------------------------------------------------------------------
                    structures
-----------------------------------------------------------------------------*/
/* for VID_ENC_SET_TYPE_FRAME_RESOLUTION */
typedef struct _VID_FRAME_RESOLUTION_T
{
    UINT32              ui4_width;      /* Resolution: Width */
    UINT32              ui4_height;     /* Resolution: Height */
} VID_FRAME_RESOLUTION_T;

typedef struct _VID_ENC_COMMON_INFO_T
{
    VID_FRAME_RESOLUTION_T  t_resolution;   /*Resolution*/
    UINT32                  ui4_fps;        /* Frame Rate */
    UINT32                  ui4_bitrate;    /* Bitrate */
	UINT32                  ui4_QP;         /*Quantization Parameter*/
} VID_ENC_COMMON_INFO_T;

typedef struct _VID_ENC_H264_INFO_T
{
    VID_ENC_COMMON_INFO_T  t_vid_enc_info;
    VID_ENC_PROFILE_T      e_profile;
    VID_ENC_LEVEL_T        e_level;
} VID_ENC_H264_INFO_T;

/* for VID_ENC_SET_TYPE_SETTINGS */
typedef struct _VID_ENC_SETTINGS_T
{
    VID_SRC_TYPE_T              e_src_type; /* Source Type */
    VID_ENC_FMT_TYPE_T          e_enc_fmt;  /* Encode Format Type */
    /* Encoding Setting according to e_enc_fmt */
    union
    {
        VID_ENC_H264_INFO_T     t_fmt_h264;
    }u_fmt;
} VID_ENC_SETTINGS_T;

#endif /* _X_VID_ENC_H_ */

